var EncodingError = require('level-errors').EncodingError;
var Transform = require('readable-stream').Transform;
var inherits = require('util').inherits;

module.exports = Decoder;
inherits(Decoder, Transform);

function Decoder(codec, options){
  Transform.call(this, { objectMode: true });

  if (options.keys && options.value) {
    this._decode = function(key, value){
      return {
        key: codec.decodeKey(key, [options]),
        value: codec.decodeValue(value, [options])
      };
    };
  } else if (options.keys) {
    this._decode = function(key) {
      return codec.decodeKey(key, [options]);
    }; 
  } else if (options.values) {
    this._decode = function(_, value){
      return codec.decodeValue(value, [options]);
    }
  } else {
    this._decode = function(){}
  }
}



Decoder.prototype._transform = function(kv, _, done){
  try {
    var value = this._decode(kv.key, kv.value);
  } catch (err) {
    return done(new EncodingError(err));
  }
  done(null, value);
}

